﻿'Option Strict On
'Option Explicit On

Namespace BL

    Public Class ContactService

        Public Function GetContacts() As List(Of DataModels.Contact)

            Dim contactData As New DAL.ContactData
            Dim contacts As List(Of DataModels.Contact) = contactData.GetContacts()
            For Each c As DataModels.Contact In contacts
                If c.Birthdate Is Nothing Then
                    c.Birthdate = "Unknown"
                End If
                If c.MobilePhone Is Nothing Then
                    c.MobilePhone = "Unknown"
                End If
                If c.EmailName Is Nothing Then
                    c.EmailName = "Unknown"
                End If
                If c.HomePhone Is Nothing Then
                    c.HomePhone = "Unknown"
                End If
                If c.Notes Is Nothing Then
                    c.Notes = ""
                End If
                If c.WorkPhone Is Nothing Then
                    c.WorkPhone = "Unknown"
                End If
            Next

            Return contacts

        End Function

        Public Sub DeleteContact(ByVal id As Integer)
            Dim contactData As New DAL.ContactData
            If contactData.DeleteContact(id) > 1 Then
                'Bad News we deleted too many records. 
            End If
        End Sub

        Public Sub AddContact(ByVal FirstName As String, ByVal LastName As String, ByVal contactTypeId As Integer, ByVal Address As String, ByVal City As String, ByVal StateOrProvince As String, ByVal PostalCode As String, ByVal WorkPhone As String, ByVal MobilePhone As String, ByVal HomePhone As String, ByVal EmailName As String, ByVal Birthdate As String, ByVal Notes As String)
            Dim contactData As New DAL.ContactData
            If contactTypeId = 0 Or FirstName = String.Empty Or LastName = String.Empty Then
                Throw New Exception("Invalid Parameters")
            Else
                Dim c As New DataModels.Contact
                c.ContactTypeID = contactTypeId
                c.FirstName = FirstName
                c.LastName = LastName
                c.Address = Address
                c.City = City
                c.StateOrProvince = StateOrProvince
                c.PostalCode = PostalCode
                c.WorkPhone = WorkPhone
                c.HomePhone = HomePhone
                c.MobilePhone = MobilePhone
                c.EmailName = EmailName
                c.Birthdate = Birthdate
                c.Notes = Notes
                contactData.InsertContact(c)
            End If
        End Sub

        Public Sub UpdateContact(ByVal contactID As Integer, ByVal FirstName As String, ByVal LastName As String, ByVal Address As String, ByVal City As String, ByVal StateOrProvince As String, ByVal PostalCode As String, ByVal WorkPhone As String, ByVal HomePhone As String, ByVal MobilePhone As String, ByVal EmailName As String, ByVal BirthDate As String, ByVal ContactTypeID As String, ByVal Notes As String)
            Dim contactData As New DAL.ContactData
            If contactID = 0 Or ContactTypeID = 0 Or FirstName = String.Empty Or LastName = String.Empty Then
                Throw New Exception("Invalid Parameters")
            Else
                Dim c As New DataModels.Contact
                c.FirstName = FirstName
                c.LastName = LastName
                c.Address = Address
                c.City = City
                c.StateOrProvince = StateOrProvince
                c.PostalCode = PostalCode
                c.WorkPhone = WorkPhone
                c.HomePhone = HomePhone
                c.MobilePhone = MobilePhone
                c.EmailName = EmailName
                c.Birthdate = BirthDate
                c.ContactTypeID = ContactTypeID
                c.Notes = Notes
                If Not contactData.UpdateContact(c) = 1 Then
                    Throw New Exception("Nothing to Update")
                End If
            End If
        End Sub

    End Class

    Public Class ContactTypeService

        Public Function GetContactType(ByVal id As Integer) As List(Of DataModels.Contact)

            Dim contactData As New DAL.ContactTypeData
            'Dim contacts As List(Of DataModels.Contact) =
            contactData.GetContactType(id)

            'Return contactData.GetContactType(id)

        End Function

        Public Function GetContactTypes() As List(Of DataModels.ContactType)

            Dim contactTypeData As New DAL.ContactTypeData
            Dim contactTypes As List(Of DataModels.ContactType) = contactTypeData.GetContactTypes()
            For Each c As DataModels.ContactType In contactTypes
                If c.ContactType Is Nothing Then
                    c.ContactType = "Unknown"
                End If
            Next
            Return contactTypes
        End Function

    End Class

End Namespace
